# -*- coding: utf-8 -*-
'''
Created on 05 nov 2024

file contains all models for recel sys 3 with all specifics for each model
@author: garzol 
search keywords: switches reset open transparent I have a alarm1
WebEngine WebView OpenGL numpy QtTextToSpeech pickle Crazy Race index ======
signaling fletcher console
230
Discussion on the Screech rom:
From the recel_games pack of zip files, one can see 
'''

class RscPin():
    '''
    '''

    ###
    dbmswt =[
        #[0][x]
        ["Ball Home",       None,                     None,                "10K pts"],
        #[1][x]
        [None,              None,                      None,                "500 pts"],
        #[2][x]
        [None,              "5K pts",                  "5K pts",             "30 pts"],
        #[3][x]
        [None,              "50K pts",                 "20K pts",             "Passage Special"],
        #[4][x]
        [None,              "Target A1",              "Target A2",             "Target A3"],
        #[5][x]
        [None,              "Target B1",              "Target B2",             "Target B3"],
        #[6][x]
        ["Bumper Left",     "Bumper Right",            "Slingshot Left",       "Slingshot Right"],
        #[7][x]
        ["Passage D.B.",    "Passage E.B.",            "Target Ball Right",    "Target Ball Left"],
        #[8][x]
        ["Fault",           "Coin 3",                  "Coin 1",               "Coin 2"],
        #[9][x]
        ["Tilt",            "Replays",                 "Button 2",             "Button 1"],
        ]

    dbmsswt =[
        #[0][x]
        ["BH",       None,      None,         "10K"],
        #[1][x]
        [None,       None,      None,          "500"],
        #[2][x]
        [None,       "5K",      "5K",          "30"],
        #[3][x]
        [None,       "50K",     "20K",         "pSp"],
        #[4][x]
        [None,       "TA1",     "TA2",          "TA3"],
        #[5][x]
        [None,       "TB1",     "TB2",          "TB3"],
        #[6][x]
        ["BL",       "BR",      "SL",           "SR"],
        #[7][x]
        ["pDB",       "pEB",    "TBR",          "TBL"],
        #[8][x]
        ["Flt",      "🪙 3",    "🪙 1",         "🪙 2"],
        #[9][x]
        ["Tlt",      "Repl",    "☜ 2",         "☜ 1"],
        ]

    ###    
    dcrswt =[
        #[0][x]
        ["Ball Home",       "Targets upper side",      "Target 50000",         "Upper hole"],
        #[1][x]
        [None,              None,                      None,                   None],
        #[2][x]
        [None,              None,                      None,                   None],
        #[3][x]
        [None,              "Aisle 100",               "Contact 30pts",        None],
        #[4][x]
        [None,              "Aisle 5000 & Bonus",      None,                   None],
        #[5][x]
        ["Target Right",    "Target Centre",           "Target Left",          None],
        #[6][x]
        ["Bumper Left",     "Bumper Right",            "Slingshot Left",       "Slingshot Right"],
        #[7][x]
        [None,              None,                      "Passage 30000",        "Slingshot Upper"],
        #[8][x]
        ["Fault",           "Coin 3",                  "Coin 1",               "Coin 2"],
        #[9][x]
        ["Tilt",            "Replays",                 "Button 2",             "Button 1"],
        ]

    dcrsswt =[
        #[0][x]
        ["BH",       "TU",      "T50K",         "UH"],
        #[1][x]
        [None,       None,      None,           None],
        #[2][x]
        [None,       None,      None,           None],
        #[3][x]
        [None,       "P100",    "30",           None],
        #[4][x]
        [None,       "5K+B",    None,           None],
        #[5][x]
        ["TR",       "TC",      "TL",           None],
        #[6][x]
        ["BL",       "BR",      "SL",           "SR"],
        #[7][x]
        [None,       None,      "P30K",         "SU"],
        #[8][x]
        ["Flt",      "🪙 3",    "🪙 1",         "🪙 2"],
        #[9][x]
        ["Tlt",      "Repl",    "☜ 2",         "☜ 1"],
        ]

    ###    

  
  
    dfaswt =[
        #[0][x]
        ["Ball Home",         "Target Lower Left",      "Target Lower Right",   "30pts SW"],
        #[1][x]
        ["Target Upper Left", "Target Upper Right",     "LH DB Rollover",       "10K SW"],
        #[2][x]
        [None,              None,                      None,                    "RH DB Rollover"],
        #[3][x]
        [None,              None,                      None,                    "500pts SW"],
        #[4][x]
        [None,              None,                      None,                    None],
        #[5][x]
        [None,              None,                      None,                    None],
        #[6][x]
        ["Bumper Upper",    "Bumper Lower",            "Slingshot Left",        "Slingshot Right"],
        #[7][x]
        ["EB Target",       "Special Rollover",         "Special Rollover",      None],
        #[8][x]
        ["Fault",           "Coin 3",                  "Coin 1",               "Coin 2"],
        #[9][x]
        ["Tilt",            "Replays",                 "Button 2",             "Button 1"],
        ]
 
    dfasswt =[
        #[0][x]
        ["BH",       "TLL",     "TLR",          "30"],
        #[1][x]
        ["TUL",      "TUR",     "LHR",          "10K"],
        #[2][x]
        [None,       None,      None,           "RHR"],
        #[3][x]
        [None,       None,      None,           "500"],
        #[4][x]
        [None,       None,      None,           None],
        #[5][x]
        [None,       None,      None,           None],
        #[6][x]
        ["BU",       "BL",      "SL",           "SR"],
        #[7][x]
        ["TEB",      "SpR",     "SpR",          None],
        #[8][x]
        ["Flt",      "🪙 3",    "🪙 1",         "🪙 2"],
        #[9][x]
        ["Tlt",      "Repl",    "☜ 2",         "☜ 1"],
        ]
  
    ###
    dcaswt =[
        #[0][x]
        ["Ball Home",       "Vari Target pos 0",      "Upper Hole",    "Lower Hole"],
        #[1][x]
        [None,              "230pts",                  None,            None],
        #[2][x]
        [None,              None,                      None,            None],
        #[3][x]
        [None,              None,                      None,            None],
        #[4][x]
        ["Star 4",         "Passage 4",                None,            "500pts"],
        #[5][x]
        ["Star 1",         "Star 2",                   None,            "Star 3"],
        #[6][x]
        ["Bumper Upper",   "Bumper Lower",             "Slingshot left","Slingshot right"],
        #[7][x]
        ["Passage 1",      "Passage 2",                "Passage Special","Passage 3"],
        #[8][x]
        ["Fault",           "Coin 3",                  "Coin 1",               "Coin 2"],
        #[9][x]
        ["Tilt",            "Replays",                 "Button 2",             "Button 1"],
        ]
 
    dcasswt =[
        #[0][x]
        ["BH",       "VT0",     "UH",         "LH"],
        #[1][x]
        [None,       "230",     None,         None],
        #[2][x]
        [None,       None,      None,         None],
        #[3][x]
        [None,       None,      None,         None],
        #[4][x]
        ["⭐ 4",    "P 4",      None,         "500"],
        #[5][x]
        ["⭐ 1",    "⭐ 2",     None,         "⭐ 3"],
        #[6][x]
        ["BU",       "BL",      "SL",          "SR"],
        #[7][x]
        ["P 1",      "P 2",     "PSp",         "P 3"],
        #[8][x]
        ["Flt",      "🪙 3",    "🪙 1",       "🪙 2"],
        #[9][x]
        ["Tlt",      "Repl",    "☜ 2",         "☜ 1"],
        ]

    dmdswt =[
        #[0][x]
        ["Ball Home",          None,                None,          "10Kpts SW"],
        #[1][x]
        [None,                 None,                None   ,       "500pts SW"],
        #[2][x]
        [None,                 None,                "5Kpts SW",    "30pts SW"],
        #[3][x]
        [None,                 "50Kpts SW",         "20Kpts SW",   None],
        #[4][x]
        [None,                 "Target A1",         "Target A2",   "Target A3"],
        #[5][x]
        [None,                 "Target B1",         "Target B2",   "Target B3"],
        #[6][x]
        ["Bumper Left",        "Bumper Right",      "Slingshot Left","Slingshot Right"],
        #[7][x]
        ["Passage DB",         "Passage EB",         "Ball Right",      "Ball Left"],
        #[8][x]
        ["Fault",           "Coin 3",                  "Coin 1",               "Coin 2"],
        #[9][x]
        ["Tilt",            "Replays",                 "Button 2",             "Button 1"],
        ]
 
    dmdsswt =[
        #[0][x]
        ["BH",       None,     None,          "10K"],
        #[1][x]
        [None,       None,      None,           "500"],
        #[2][x]
        [None,       None,      None,           "30"],
        #[3][x]
        [None,       "50K",     "20K",          None],
        #[4][x]
        [None,       "TA1",     "TA2",          "TA3"],
        #[5][x]
        [None,       "TB1",     "TB2",          "TB3"],
        #[6][x]
        ["BL",       "BR",      "SL",           "SR"],
        #[7][x]
        ["pDB",      "pEB",     "Bo L",         "Bo R"],
        #[8][x]
        ["Flt",      "🪙 3",    "🪙 1",         "🪙 2"],
        #[9][x]
        ["Tlt",      "Repl",    "☜ 2",         "☜ 1"],
        ]

    ###
    dposwt =[
        #[0][x]
        ["Ball Home",          "LH UP Lite x10 and 10K Rollover", "RH UP Lite x10 and 10K Rollover",   "LH RH Lite x10 Rollover"],
        #[1][x]
        ["Left x10 Rollover",  "LH Lite x10 Rollover",            "RH Lite x10 Rollove",               "Right x10 Rollover"],
        #[2][x]
        ["Special Rollover",   "Central D.B. Target",             "Rollover 500pts",                   "Rollover 10,000pts"],
        #[3][x]
        ["Target 1",           "Target 2",                        "Target 3",                          "Target 4"],
        #[4][x]
        [None,                 None,                              None,                                None],
        #[5][x]
        [None,                 None,                              None,                                None],
        #[6][x]
        ["Bumper",             "LH Slingshot",                    "RH Slingshot",                      "Upper Slingshot"],
        #[7][x]
        [None,                 None,                              None,                                "E.B. Target"],
        #[8][x]
        ["Fault",           "Coin 3",                  "Coin 1",               "Coin 2"],
        #[9][x]
        ["Tilt",            "Replays",                 "Button 2",             "Button 1"],
        ]
   
    dposswt =[
        #[0][x]
        ["BH",       "LUR",     "RUR",         "Rx10"],
        #[1][x]
        ["Lx10R",    "Lx10R",   "Rx10R",       "Rx10R"],
        #[2][x]
        ["Spe",      "T C",    "500",          "10K"],
        #[3][x]
        ["T1",       "T2",     "T3",           "T4"],
        #[4][x]
        [None,       None,     None,           None],
        #[5][x]
        [None,       None,     None,           None],
        #[6][x]
        ["Bmp",      "SL",     "SR",           "SU"],
        #[7][x]
        ["TEB",      None,     None,           None],
        #[8][x]
        ["Flt",      "🪙 3",    "🪙 1",         "🪙 2"],
        #[9][x]
        ["Tlt",      "Repl",    "☜ 2",         "☜ 1"],
        ]
 
        ###
    dquswt =[
        #[0][x]
        ["Ball Home",       "230pts",                 "Lower Hole",    "Upper Hole"],
        #[1][x]
        [None,              None,                      None,            "Lower Passage Left"],
        #[2][x]
        [None,              None,                      None,            None],
        #[3][x]
        [None,              "Target A1",               "Target A2",     "Target A3"],
        #[4][x]
        ["Passage 5Kpts",   "Target B1",               "Target B2",     "Target B3"],
        #[5][x]
        ["Passage Bonus x3",None,                      "Passage Special","500pts"],
        #[6][x]
        ["Passage D.B.",   "Upper Passage 50Kpts",     "Passage E.B.",   "Target E.B."],
        #[7][x]
        ["Upper Bumper",   "Lower Bumper",             "Slingshot Right","Target D.B."],
        #[8][x]
        ["Fault",           "Coin 3",                  "Coin 1",               "Coin 2"],
        #[9][x]
        ["Tilt",            "Replays",                 "Button 2",             "Button 1"],
        ]
 
    dqusswt =[
        #[0][x]
        ["BH",       "230",     "LH",         "UH"],
        #[1][x]
        [None,       None,     None,         "lp"],
        #[2][x]
        [None,       None,      None,         None],
        #[3][x]
        [None,       "TA1",     "TA2",        "TA3"],
        #[4][x]
        ["p5K",      "TB1",     "TB2",        "TB3"],
        #[5][x]
        ["x3B",      None,      "pSpe",       "500"],
        #[6][x]
        ["x2B",      "Up50K",    "pEB",       "TEB"],
        #[7][x]
        ["BU",       "BL",       "SR",         "TDB"],
        #[8][x]
        ["Flt",      "🪙 3",    "🪙 1",       "🪙 2"],
        #[9][x]
        ["Tlt",      "Repl",    "☜ 2",         "☜ 1"],
        ]

    
    ###
    dscswt =[
        #[0][x]
        ["Ball Home",          "Canon Right",      "Canon Left",   None],
        #[1][x]
        ["Total Left Bank",    "Passage Central Left",  "Bands",   "Passage Central Lower"],
        #[2][x]
        ["Total Right Bank",   "Passage Central Right", "Target internal Left",    None],
        #[3][x]
        [None,                 "Passage Upper Left",    "Target internal Right",   "Bands Behind Bank"],
        #[4][x]
        ["Target A Left",      "Target B Left",         "Target C Left",           "Target D Left"],
        #[5][x]
        ["Target A Right",     "Target B Right",        "Target C Right",          "Target D Right"],
        #[6][x]
        ["Bumper Left",        "Bumper Right",          "Bumper Lower",            "Passage Upper Lateral Right"],
        #[7][x]
        ["Target Special Left","Target Special Right",  "Passage Lower Lateral Left", "Passage Lower Lateral Right"],
        #[8][x]
        ["Fault",           "Coin 3",                  "Coin 1",               "Coin 2"],
        #[9][x]
        ["Tilt",            "Replays",                 "Button 2",             "Button 1"],
        ]
   
    dscsswt =[
        #[0][x]
        ["BH",       "CR",     "CL",           None],
        #[1][x]
        ["TLB",      "pCL",    "Bnd",          "pCL"],
        #[2][x]
        ["TRB",      "pCR",    "TIL",          None],
        #[3][x]
        [None,       "pUL",    "TIR",          "BbB"],
        #[4][x]
        ["TAL",       "TBL",    "TCL",         "TDL"],
        #[5][x]
        ["TAR",       "TBR",    "TCR",         "TDR"],
        #[6][x]
        ["BL",        "BR",     "BLo",         "pULR"],
        #[7][x]
        ["TSpL",      "TSpR",   "pLLL",         "pLLR"],
        #[8][x]
        ["Flt",      "🪙 3",    "🪙 1",         "🪙 2"],
        #[9][x]
        ["Tlt",      "Repl",    "☜ 2",         "☜ 1"],
        ]
    ###

    ###
    dswswt =[
        #[0][x]
        ["Ball Home",       "Vari Target pos 0",      "Upper Hole",    "Lower Hole"],
        #[1][x]
        [None,              "230pts",                  None,            None],
        #[2][x]
        [None,              None,                      None,            None],
        #[3][x]
        [None,              None,                      None,            None],
        #[4][x]
        ["Star 4",         "Passage 4",                None,            "500pts"],
        #[5][x]
        ["Star 1",         "Star 2",                   None,            "Star 3"],
        #[6][x]
        ["Bumper Upper",   "Bumper Lower",             "Slingshot left","Slingshot right"],
        #[7][x]
        ["Passage 1",      "Passage 2",                "Passage Special","Passage 3"],
        #[8][x]
        ["Fault",           "Coin 3",                  "Coin 1",               "Coin 2"],
        #[9][x]
        ["Tilt",            "Replays",                 "Button 2",             "Button 1"],
        ]
 
    dswsswt =[
        #[0][x]
        ["BH",       "VT0",     "UH",         "LH"],
        #[1][x]
        [None,       "230",     None,         None],
        #[2][x]
        [None,       None,      None,         None],
        #[3][x]
        [None,       None,      None,         None],
        #[4][x]
        ["⭐ 4",    "P 4",      None,         "500"],
        #[5][x]
        ["⭐ 1",    "⭐ 2",     None,         "⭐ 3"],
        #[6][x]
        ["BU",       "BL",      "SL",          "SR"],
        #[7][x]
        ["P 1",      "P 2",     "PSp",         "P 3"],
        #[8][x]
        ["Flt",      "🪙 3",    "🪙 1",       "🪙 2"],
        #[9][x]
        ["Tlt",      "Repl",    "☜ 2",         "☜ 1"],
        ]

    ###
    dtoswt =[
        #[0][x]
        ["Ball Home",         "Target Lower Left",      "Target Lower Right",   "30pts SW"],
        #[1][x]
        ["Target Upper Left", "Target Upper Right",     "LH DB Rollover",       "10K SW"],
        #[2][x]
        [None,              None,                      None,                    "RH DB Rollover"],
        #[3][x]
        [None,              None,                      None,                    "500pts SW"],
        #[4][x]
        [None,              None,                      None,                    None],
        #[5][x]
        [None,              None,                      None,                    None],
        #[6][x]
        ["Bumper Upper",    "Bumper Lower",            "Slingshot Left",        "Slingshot Right"],
        #[7][x]
        ["EB Target",       "Special Rollover",         "Special Rollover",      None],
        #[8][x]
        ["Fault",           "Coin 3",                  "Coin 1",               "Coin 2"],
        #[9][x]
        ["Tilt",            "Replays",                 "Button 2",             "Button 1"],
        ]
 
    dtosswt =[
        #[0][x]
        ["BH",       "TLL",     "TLR",          "30"],
        #[1][x]
        ["TUL",      "TUR",     "LHR",          "10K"],
        #[2][x]
        [None,       None,      None,           "RHR"],
        #[3][x]
        [None,       None,      None,           "500"],
        #[4][x]
        [None,       "5K+B",    None,           None],
        #[5][x]
        [None,       None,      None,           None],
        #[6][x]
        ["BU",       "BL",      "SL",           "SR"],
        #[7][x]
        ["TEB",      "SpR",     "SpR",          None],
        #[8][x]
        ["Flt",      "🪙 3",    "🪙 1",         "🪙 2"],
        #[9][x]
        ["Tlt",      "Repl",    "☜ 2",         "☜ 1"],
        ]
  
    ###
    dxxswt =[
        #[0][x]
        ["Ball Home",       None,                     None,                     None],
        #[1][x]
        [None,              None,                      None,                    None],
        #[2][x]
        [None,              None,                      None,                    None],
        #[3][x]
        [None,              None,                      None,                    None],
        #[4][x]
        [None,              None,                      None,                    None],
        #[5][x]
        [None,              None,                      None,                    None],
        #[6][x]
        [None,              None,                      None,                    None],
        #[7][x]
        [None,              None,                      None,                    None],
        #[8][x]
        ["Fault",           "Coin 3",                  "Coin 1",               "Coin 2"],
        #[9][x]
        ["Tilt",            "Replays",                 "Button 2",             "Button 1"],
        ]
 
    dxxsswt =[
        #[0][x]
        ["BH",       None,      None,           None],
        #[1][x]
        [None,       None,      None,           None],
        #[2][x]
        [None,       None,      None,           None],
        #[3][x]
        [None,       None,      None,           None],
        #[4][x]
        [None,       None,      None,           None],
        #[5][x]
        [None,       None,      None,           None],
        #[6][x]
        [None,       None,      None,           None],
        #[7][x]
        [None,       None,      None,           None],
        #[8][x]
        ["Flt",      "🪙 3",    "🪙 1",         "🪙 2"],
        #[9][x]
        ["Tlt",      "Repl",    "☜ 2",         "☜ 1"],
        ]
  
    ###

    dal = {
        "#Model"          : "0000",       #TODO
        "Game bin"        : "al.bin",
        "Game Fletcher"   : 0x85F5,
        "A1762 bin"       : "A1762-13_1K.bin",
        "Switches"        : dxxswt,       #TODO
        "Switches short"  : dxxsswt,      #TODO
        }

    dbm = {
        "#Model"          : "1065",   
        "Game bin"        : "bmgame.bin",
        "Game Fletcher"   : 0x79F1,   
        "A1762 bin"       : "bmA1762.bin",
        "Switches"        : dbmswt,   
        "Switches short"  : dbmsswt,   
        }
        
    dbm4 = {
        "#Model"          : "1066",   
        "Game bin"        : "b4game.bin",
        "Game Fletcher"   : 0xF9E4,   
        "A1762 bin"       : "b4A1762.bin",
        "Switches"        : dbmswt,   
        "Switches short"  : dbmsswt,
        }
        
    dca = {
        "#Model"          : "1062",
        "Game bin"        : "ca.bin",
        "Game Fletcher"   : 0x026C,
        "A1762 bin"       : "A1762-13_1K.bin",
        "Switches"        : dcaswt,
        "Switches short"  : dcasswt,
        
        }
  
    dcr = {
        "#Model"          : "1054",
        "Game bin"        : "crgamex4.bin",
        "Game Fletcher"   : 0x7F5D,
        "A1762 bin"       : "crA1762.bin",
        "Switches"        : dcrswt,
        "Switches short"  : dcrsswt,
        "Backglass"       : "crazy_race_480.png",
        }
        
    dfa = {
        "#Model"          : "1053",
        "Game bin"        : "fa.bin",
        "Game Fletcher"   : 0x3DEB,
        "A1762 bin"       : "A1762-13_1K.bin",
        "Switches"        : dfaswt,
        "Switches short"  : dfasswt,
        "Backglass"       : "fair_fight_480.png",
        }
        
    dhc = {
        "#Model"          : "0000",    #TODO
        "Game bin"        : "hc.bin",
        "Game Fletcher"   : 0x4B8B,
        "A1762 bin"       : "A1762-13_1K.bin",
        "Switches"        : dxxswt,     #TODO
        "Switches short"  : dxxsswt,    #TODO
        }
        
    dfl = {
        "#Model"          : "0000",    #TODO
        "Game bin"        : "flgame.bin",
        "Game Fletcher"   : 0x4EA1,    
        "A1762 bin"       : "flA1762.bin",
        "Switches"        : dxxswt,     #TODO
        "Switches short"  : dxxsswt,    #TODO
        }
        
    dmd = {
        "#Model"          : "1060",    
        "Game bin"        : "md.bin",
        "Game Fletcher"   : 0xA5D6,
        "A1762 bin"       : "A1762-13_1K.bin",
        "Switches"        : dmdswt,     
        "Switches short"  : dmdsswt,    
        }
    
    dme = {
        "#Model"          : "1055",    # 1 player
        "Game bin"        : "me.bin",
        "Game Fletcher"   : 0x4FB3,      
        "A1762 bin"       : "A1762-13_1K.bin",
        "Switches"        : dxxswt,     #TODO
        "Switches short"  : dxxsswt,    #TODO
        }
        
    dpo = {
        "#Model"          : "1051",    #1051-E to be exact
        "Game bin"        : "po.bin",
        "Game Fletcher"   : 0x869A,
        "A1762 bin"       : "A1762-13_1K.bin",
        "Switches"        : dposwt,     
        "Switches short"  : dposswt,    
        }
        
    dpo2 = {
        "#Model"          : "1051",    #1051-E to be exact
        "Game bin"        : "pokerplus_BA65.BIN",
        "Game Fletcher"   : 0xE43E,
        "A1762 bin"       : "A1762-13_1K.bin",
        "Switches"        : dposwt,     
        "Switches short"  : dposswt,    
        }
        
    dqu = {
        "#Model"          : "1063",    
        "Game bin"        : "qu.bin",
        "Game Fletcher"   : 0x9F36,      
        "A1762 bin"       : "A1762-13_1K.bin",
        "Switches"        : dquswt,     
        "Switches short"  : dqusswt,    
        }
        
    dsc = {
        "#Model"          : "2004",    
        "Game bin"        : "sc_1_1702.bin",
        "Game Fletcher"   : 0xF4F0,     #TODO 
        "A1762 bin"       : "A1762-13_1K.bin",
        "Switches"        : dscswt,     
        "Switches short"  : dscsswt,
        "Backglass"       : "screech_480.png",
        }
                
    dsw = {
        "#Model"          : "1061",    
        "Game bin"        : "sw.bin",
        "Game Fletcher"   : 0xCDE9,      
        "A1762 bin"       : "A1762-13_1K.bin",
        "Switches"        : dswswt,          #Same as for Cavalier  
        "Switches short"  : dswsswt,         #Same as for Cavalier
        }
        
    dto = {
        "#Model"          : "1056",    
        "Game bin"        : "to.bin",
        "Game Fletcher"   : 0xC465,      
        "A1762 bin"       : "A1762-13_1K.bin",
        "Switches"        : dtoswt,          #Same as for Fair Fight
        "Switches short"  : dtosswt,         #Same as for Fair Fight
        }
        
    
    Models = {
        'Alaska'                 : dal,
        'Black Magic 1 player'   : dbm,
        'Black Magic 4 players'  : dbm4,
        'Cavalier'               : dca,    #done
        'Crazy Race'             : dcr,    #done
        'Fair Fight'             : dfa,    #done
        'The Flipper Game'       : dfl,
        'Hot & Cold'             : dhc,
        'Mr Doom'                : dmd,
        'Mr Evil'                : dme,
        'Poker Plus'             : dpo,
        'Poker Plus V2'          : dpo2,
        'Don Quijote'            : dqu,
        'Screech'                : dsc,    #done
        'Swashbuckler'           : dsw,
        'Torneo'                 : dto,
        }

    
    Bios = {
        0x4685             : (["A1762-13_1K.bin", "b4A1762.bin", "bmA1762.bin"], "Original A1762"),
        0xC259             : (["flA1762.bin"], "FL 2716 Mod"),
        0xDC38             : (["crA1762.bin"], "CR 2716 Mod"),
        }